/* 
    AVR Spy Include Header File 
*/

#include "defines.h"

#include <inttypes.h>
#include <ctype.h>
//#include <stdint.h>
#include <stdlib.h>
#include <string.h>

#include <avr/io.h>
//#include <avr/interrupt.h>
//#include <avr/sleep.h>

// Spy Core

typedef int(SPY_CB_FUNC)(char* cmdline);

void spy_init(SPY_CB_FUNC *tool_callback); // tool_callback can be 0
void spy_loop(void);  // eternal loop until 'q(uit)'
int  spy_step(void);  // non-blocking step function (feed Spy from your mainloop)

// Exported Tool Functions

uint16_t ADC_initReadSingle(uint8_t channel);
void timer1_init_pwm16bit(uint16_t init_value, uint16_t max_count, uint8_t prescale) ;
void timer1_set_pwm16bit(uint16_t v) ;
int parseAZaz09_(char** ps, char *x, int xmax) ;
int parseCmpI(char** ps, char *x) ;  // comparing case insensitive
int parseHEX(char** ps, unsigned *x) ;
int parseDEC(char** ps, unsigned *x) ;
void spy_uart_init(unsigned UART_BUAD) ;
int spy_putc(char c) ;
int spy_puts(char *s) ;
int spy_getc(void) ;



#define SETBIT(SFRX,BITX) SFRX |= (1<<BITX)
#define CLRBIT(SFRX,BITX) SFRX &= ~(1<<BITX)
#define INVBIT(SFRX,BITX) SFRX ^= (1<<BITX)  // not atomic!
#define AINVBIT(SFRX,BITX) { uint8_t sreg = SREG; cli(); SFRX ^= (1<<BITX); SREG=sreg; }  // atomic!
#define TESTBIT(SFRX,BITX) (SFRX&(1<<BITX))
#define WRITEBIT(SFRX,BITX,VALX) if (VALX) SETBIT(SFRX,BITX); else CLRBIT(SFRX,BITX)

#define ARRAYLEN(x) (sizeof(x)/sizeof(x[0]))
